//Software base para OPS010
//Controlador ESP32
//Mapeamento dos IOs e definição das Seriais
// Definição dos pinos do controlador
//Saidas digiais
#define pin_Y1 13
#define pin_Y2 12
#define pin_Y3 27
#define pin_Y4 26
#define pin_Y5 25
#define pin_Y6 33
#define pin_Y7 32
#define pin_Y8 4

//Entradas digitais
#define pin_X1 15
#define pin_X2 14
#define pin_X3 5
#define pin_X4 18
#define pin_X5 19
#define pin_X6 36
#define pin_X7 39
#define pin_X8 34

//Entradas analógicas
#define pin_AI1 35

//Saídas analógicas
#define pin_AO1 23

//Pinos auxiliares
#define ENTX_pin 2 //Pino de comunicação RS485

//Variaveis para controle das entradas e saidas digitais
bool Digital_Out[8];
bool Digital_In[8];
int Analog_In[1];
int Analog_Out[1];

void setup() {
  //Inicializa comunicações
  Serial.begin(115200); // (USB)
  Serial1.begin(115200); // (TTL)
  Serial2.begin(115200); //(485)

  //Inicializa hardware
  pinMode(pin_X1, INPUT);
  pinMode(pin_X2, INPUT);
  pinMode(pin_X3, INPUT);
  pinMode(pin_X4, INPUT);
  pinMode(pin_X5, INPUT);
  pinMode(pin_X6, INPUT);
  pinMode(pin_X7, INPUT);
  pinMode(pin_X8, INPUT);

  pinMode(pin_Y1, OUTPUT);
  pinMode(pin_Y2, OUTPUT);
  pinMode(pin_Y3, OUTPUT);
  pinMode(pin_Y4, OUTPUT);
  pinMode(pin_Y5, OUTPUT);
  pinMode(pin_Y6, OUTPUT);
  pinMode(pin_Y7, OUTPUT);
  pinMode(pin_Y8, OUTPUT);
  pinMode(ENTX_pin, OUTPUT);

  digitalWrite(pin_Y1, LOW);
  digitalWrite(pin_Y2, LOW);
  digitalWrite(pin_Y3, LOW);
  digitalWrite(pin_Y4, LOW);
  digitalWrite(pin_Y5, LOW);
  digitalWrite(pin_Y6, LOW);
  digitalWrite(pin_Y7, LOW);
  digitalWrite(pin_Y8, LOW);

  // Configuração da saída analógica
  //(Canal, Frequência, Resolução)
  ledcSetup(0, 1000, 12);
  //(Pino, Canal)
  ledcAttachPin(pin_AO1, 0);
}

void loop() {
  //************************************************************************************
  //Leitura das entradas digitais
  //Esse código deve rodar sempre para leitura das entradas digitais
  //Utilizar o Array Digital_In[0] a Digital_In[7] no software para controle
  //************************************************************************************
  Digital_In[0] = !digitalRead(pin_X1);
  Digital_In[1] = !digitalRead(pin_X2);
  Digital_In[2] = !digitalRead(pin_X3);
  Digital_In[3] = !digitalRead(pin_X4);
  Digital_In[4] = !digitalRead(pin_X5);
  Digital_In[5] = !digitalRead(pin_X6);
  Digital_In[6] = !digitalRead(pin_X7);
  Digital_In[7] = !digitalRead(pin_X8);

  //************************************************************************************
  //Escrita das saídas digitais
  //Esse código deve rodar sempre para escrita das saidas digitais
  //Utilizar o Array Digital_Out[0] a Digital_Out[7] no software para controle
  //************************************************************************************
  digitalWrite(pin_Y1, Digital_Out[0]);
  digitalWrite(pin_Y2, Digital_Out[1]);
  digitalWrite(pin_Y3, Digital_Out[2]);
  digitalWrite(pin_Y4, Digital_Out[3]);
  digitalWrite(pin_Y5, Digital_Out[4]);
  digitalWrite(pin_Y6, Digital_Out[5]);
  digitalWrite(pin_Y7, Digital_Out[6]);
  digitalWrite(pin_Y8, Digital_Out[7]);

  //************************************************************************************
  //Leitura das entradas Analógicas
  //Esse código deve rodar sempre para leitura das entradas analógicas
  //Utilizar o Array Analog_In[0] no software para controle
  //************************************************************************************
  Analog_In[0] = analogRead(pin_AI1);

  //************************************************************************************
  //Escrita das saídas Analógicas / 0 >= dutyCycle <= 3722 (0-10V)
  //Esse código deve rodar sempre para escrita das saidas analógicas
  //Utilizar o Array Analog_Out[0] no software para controle
  //************************************************************************************
  ledcWrite(0, Analog_Out[0]);

}
